from collections.abc import MutableMapping
from typing import Generic, Iterable, Optional, SupportsIndex, TypeVar

from fastomit.types import ListStr, bool_opt

T = TypeVar("T")

def reset_always(): ...
def always_omit(targets: ListStr): ...
def globally_hidden() -> ListStr: ...
def hide(target: str) -> str: ...

class ListLike(Generic[T], Iterable, SupportsIndex): ...

class Omitter:
    omissions: list[str]

    def __init__(self, omissions: Optional[ListStr] = None) -> None: ...
    def omit(self, target: MutableMapping) -> dict: ...
    def omit_recurse(self, target: ListLike, do: bool_opt = True) -> ListLike: ...
